package com.zhongzheng.modules.bank.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.bank.bo.QuestionBankExamAddBo;
import com.zhongzheng.modules.bank.bo.QuestionBankExamEditBo;
import com.zhongzheng.modules.bank.bo.QuestionBankExamQueryBo;
import com.zhongzheng.modules.bank.domain.QuestionBankExam;
import com.zhongzheng.modules.bank.mapper.QuestionBankExamMapper;
import com.zhongzheng.modules.bank.mapper.QuestionBankSectionMapper;
import com.zhongzheng.modules.bank.service.IQuestionBankExamService;
import com.zhongzheng.modules.bank.vo.QuestionBankExamVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;


import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 题库试卷Service业务层处理
 *
 * @author ruoyi
 * @date 2021-05-20
 */
@Service
public class QuestionBankExamServiceImpl extends ServiceImpl<QuestionBankExamMapper, QuestionBankExam> implements IQuestionBankExamService {

    @Autowired
    private QuestionBankExamMapper questionBankExamMapper;

    @Override
    public QuestionBankExamVo queryById(Long examId){
        QuestionBankExam db = this.baseMapper.selectById(examId);
        return BeanUtil.toBean(db, QuestionBankExamVo.class);
    }

    @Override
    public List<QuestionBankExamVo> queryList(QuestionBankExamQueryBo bo) {
        LambdaQueryWrapper<QuestionBankExam> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getBankId() != null, QuestionBankExam::getBankId, bo.getBankId());
        lqw.like(StrUtil.isNotBlank(bo.getName()), QuestionBankExam::getName, bo.getName());
        lqw.eq(bo.getSort() != null, QuestionBankExam::getSort, bo.getSort());
        lqw.eq(bo.getStatus() != null, QuestionBankExam::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<QuestionBankExamVo> selectBankExamList(QuestionBankExamQueryBo bo) {
        return questionBankExamMapper.selectBankExamList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<QuestionBankExamVo> entity2Vo(Collection<QuestionBankExam> collection) {
        List<QuestionBankExamVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, QuestionBankExamVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<QuestionBankExam> page = (Page<QuestionBankExam>)collection;
            Page<QuestionBankExamVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(QuestionBankExamAddBo bo) {
        QuestionBankExam add = BeanUtil.toBean(bo, QuestionBankExam.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(QuestionBankExamEditBo bo) {
        QuestionBankExam update = BeanUtil.toBean(bo, QuestionBankExam.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(QuestionBankExam entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
